package rozdzial14c;

import javafx.animation.AnimationTimer;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

import java.time.Duration;
import java.time.Instant;

/**
 * @author Jacek Piechota
 <p>W tej klasie używamy {@code AnimationTimer}. Sprawdzamy ile czasu trwa animacja, w której
 nie kontrolujemy czasu trwania ani liczby ramek.</p>
 <p>Po uruchomieniu klasy na konsoli zobaczymy na przykład:</p>
 <p>{@code Czas trwania: 2483}</p>
 */
public class Listing14c_04a extends Application {
    private double radius = 10.0;
    private Circle circle;
    private Instant start;

    @Override
    public void start(Stage stage) {
        StackPane root = new StackPane();
        circle = new Circle(radius);
        circle.setFill(Color.DARKCYAN);
        root.getChildren().add(circle);
        AnimationTimer timer = new MyTimer();
        timer.start();
        start=Instant.now();
        Scene scene = new Scene(root, 300, 300);
        stage.setTitle("AnimationTimer");
        stage.setScene(scene);
        stage.show();
    }

    private class MyTimer extends AnimationTimer {
        @Override
        public void handle(long now) {
            System.out.println(now);
            radius += 0.5;
            circle.radiusProperty().set(radius);
            if (radius >= 80.0) {
                radius = 10.0;
                circle.radiusProperty().set(radius);
                stop();
                Instant end = Instant.now();
                long millis = Duration.between(start,
                        end).toMillis();
                System.out.println("Czas trwania: "+ millis);
            }
        }
    }

    public static void main(String[] args) {
        Application.launch(args);
    }
}